try(DestroyDialog RolbatchImport ) catch()
rollout RolbatchImport "FolderBrowserDialog_ForOBJ" 
(
	button BtnStart "Import" 
	dropdownlist  DrplisImportClass "ImpClass" 
	local DialogCurDir
	on RolbatchImport open  do
	(
		local CollImpClassA = ImporterPlugin.Classes
		local  drpItems = for fe in CollImpClassA collect fe as string
		DrplisImportClass.Items = drpItems
		DialogCurDir = GetDir #import
	)
	on BtnStart pressed  do
	(
		local importClass =  ImporterPlugin.Classes[DrplisImportClass.Selection]
		local DotNetFolderBrowser = DotNetObject "System.Windows.Forms.FolderBrowserDialog"
		local ClassAndFilterArray = #(
		#("ObjImp","*.obj"), 
		#("3D_Studio","*.3ds;*.prj"),
		#("3D_Studio_Shape","*.shp"),
		#("Adobe_Illustrator_Shape","*.ai"),
		#("AutoCADImport","*.dwg,*.dxf"),
		#("DAEIMP","*.dae"),
		#("FBXIMP","*.fbx"),
		#("FileLinkAsDwgImporter","*.dwg"), 
		#("FltImport","*.dae"), 
		#("IGES_Import","*.ige;*.igs;*.iges"),
		#("ImportHTR","*.htr"), 
		#("ImportTRC","*.trc"),
		#("InventorImport","*.ipt,*.iam"),
		#("LandXML___DEM_Model_Import","*.dem;*.xml;*.ddf"),
		#("Lightscape_Importer","*.ls;*.vw;*.lp"), 
		#("mental_ray_Import","*.xml"),
		#("STL_Import","*.stl"), 
		#("VrmlImp","*.wrl;*.wrz"),
		#("Wavefront_Object","*.obj"),
		#("XMLImp2","*.xml")
		)
		
		local CurImpClassFilter
		local CurImpExtension
		for Fc in ClassAndFilterArray do
		(
			if Fc[1] == (importClass as string) do
			(
				CurImpClassFilter =  Fc[1] + "(" + Fc[2] + ")|" + Fc[2]
				CurImpExtension = Fc[2]
			)
		)
		
		local DotnetGetname = DotNetFolderBrowser.ShowDialog()
		if (DotnetGetname.Equals DotnetGetname.OK) do
		(
			local SelectedPath = DotNetFolderBrowser.SelectedPath;			
			local FileNames = GetFiles(SelectedPath + "\\" + CurImpExtension);
			local FolderNames = GetDirectories(SelectedPath +"/*");
			
			function recursionFolders FolderPath FileNamesA Extension myself =
			(
				local FileNames = GetFiles(FolderPath + "\\" + Extension);
				join FileNamesA FileNames
				
				local FolderNames = GetDirectories(FolderPath +"/*");
				for Fi in FolderNames do
				(
					myself Fi FileNamesA Extension myself
				)
			)
			
			for Fi in FolderNames do
			(
				recursionFolders Fi FileNames CurImpExtension recursionFolders;
			)
			
			if FileNames.count >= 1 then
			(
				for Fi = 1 to FileNames.Count do
				(
					if Fi == 1 then
					(
						importFile FileNames[Fi] using:importClass
					) 
					else
					(
						importFile FileNames[Fi]   #noPrompt using:importClass
					) 
				)
			)
		)
	)
)
CreateDialog RolbatchImport
